com.jogamp.opengl.util.packrect

## Interface BackingStoreManager

-     public interface BackingStoreManager

  This interface must be implemented by the end user and is called in response to events like addition of rectangles into the RectanglePacker. It is used both when a full re-layout must be done as well as when the data in the backing store must be copied to a new one.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `additionFailed(Rect cause, int attemptNumber)` Notification that addition of the given Rect failed because a maximum size was set in the RectanglePacker and the backing store could not be expanded, or because compaction (and, therefore, implicitly expansion) was not supported.
    `Object` | `allocateBackingStore(int w, int h)`
    `void` | `beginMovement(Object oldBackingStore, Object newBackingStore)` Notification that movement is starting.
    `boolean` | `canCompact()` Indication whether this BackingStoreManager supports compaction; in other words, the allocation of a new backing store and movement of the contents of the backing store from the old to the new one.
    `void` | `deleteBackingStore(Object backingStore)`
    `void` | `endMovement(Object oldBackingStore, Object newBackingStore)` Notification that movement is ending.
    `void` | `move(Object oldBackingStore, Rect oldLocation, Object newBackingStore, Rect newLocation)` Tells the manager to move the contents of the given rect from the old location on the old backing store to the new location on the new backing store.
    `boolean` | `preExpand(Rect cause, int attemptNumber)` Notification that expansion of the backing store is about to be done due to addition of the given rectangle.

- - ### Method Detail

    - #### allocateBackingStore

          Object allocateBackingStore(int w,
                                    int h)

    - #### deleteBackingStore

          void deleteBackingStore(Object backingStore)

    - #### canCompact

          boolean canCompact()

      Indication whether this BackingStoreManager supports compaction; in other words, the allocation of a new backing store and movement of the contents of the backing store from the old to the new one. If it does not, then RectanglePacker.add() may throw an exception if additionFailed() can not make enough room available. If an implementation returns false, this also implies that the backing store can not grow, so that preExpand() will never be called.

    - #### preExpand

          boolean preExpand(Rect cause,
                          int attemptNumber)

      Notification that expansion of the backing store is about to be done due to addition of the given rectangle. Gives the manager a chance to do some compaction and potentially remove old entries from the backing store, if it acts like a least-recently-used cache. This method receives as argument the number of attempts so far to add the given rectangle. Manager should return true if the RectanglePacker should retry the addition (which may result in this method being called again, with an increased attempt number) or false if the RectanglePacker should just expand the backing store. The caller should not call RectanglePacker.add() in its preExpand() method.

    - #### additionFailed

          boolean additionFailed(Rect cause,
                               int attemptNumber)

      Notification that addition of the given Rect failed because a maximum size was set in the RectanglePacker and the backing store could not be expanded, or because compaction (and, therefore, implicitly expansion) was not supported. Should return false if the manager can do nothing more to handle the failed addition, which will cause a RuntimeException to be thrown from the RectanglePacker.

    - #### beginMovement

          void beginMovement(Object oldBackingStore,
                           Object newBackingStore)

      Notification that movement is starting.

    - #### move

          void move(Object oldBackingStore,
                  Rect oldLocation,
                  Object newBackingStore,
                  Rect newLocation)

      Tells the manager to move the contents of the given rect from the old location on the old backing store to the new location on the new backing store. The backing stores can be identical in the case of compacting the existing backing store instead of reallocating it.

    - #### endMovement

          void endMovement(Object oldBackingStore,
                         Object newBackingStore)

      Notification that movement is ending.

Copyright 2010 JogAmp Community.